// Copyright 2001 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.

#import "OWCSSNumber.h"

#import <Foundation/Foundation.h>
#import <OmniBase/OmniBase.h>

RCS_ID("$Header: /Network/Source/CVS/OmniGroup/Frameworks/OWF/CSS.subproj/OWCSSNumber.m,v 1.4 2001/03/04 12:09:27 wjs Exp $");

@interface OWCSSNumber (Private)
@end

@implementation OWCSSNumber

static OWCSSNumber *currentFontSizeNumber;
static OWCSSNumber *standardIndentNumber;

+ (OWCSSNumber *)numberWithFloatValue:(float)newFloatValue unitsString:(NSString *)newUnitsString;
{
    return [[[self alloc] initWithFloatValue:newFloatValue unitsString:newUnitsString] autorelease];
}


+ (OWCSSNumber *)currentFontSizeNumber;
{
    return currentFontSizeNumber;
}

+ (OWCSSNumber *)standardIndentNumber;
{
    return standardIndentNumber;
}

+ (void)initialize;
{
    OBINITIALIZE;
 
    currentFontSizeNumber = [[self alloc] initWithFloatValue:1.0 unitsString:@"em"];
    standardIndentNumber = [[self alloc] initWithFloatValue:2.75 unitsString:@"em"];
}

// Init and dealloc

- initWithFloatValue:(float)newFloatValue unitsString:(NSString *)newUnitsString;
{
    if (![super init])
        return self;

    floatValue = newFloatValue;
    unitsString = [newUnitsString retain];
    return self;
}

- (void)dealloc;
{
    [unitsString release];
    [super dealloc];
}


// API

- (float)floatValue;
{
    return floatValue;
}
- (NSString *)unitsString;
{
    return unitsString;
}


@end

@implementation OWCSSNumber (Private)

- (NSString *)descriptionWithLocale:(NSDictionary *)locale indent:(unsigned)level;
{
    return [NSString stringWithFormat:@"%.1f%@", floatValue, unitsString];
}

@end
